// Max distance value between neighbors.
// It is used to check if two nodes are neighbor of each other
var DISTANCE_CONS = 46; // 18 + 28; 

//The following algorithm is used to generate 
//the valid walkable path for the rabbit. It will grow
//the path from incomplete ones to the complete ones.

// Initialise the path generation
function initPath(){
	
    var initialPath = [];
	
	//Check surrounding 6 neighbors and initialise the walkablePath	array.
	for(var i = 0; i < gameObjArr.length; i++){
		for(var j = 0; j < gameObjArr[i].length; j++){	
			if(isNeighbor(currentRabbit, gameObjArr[i][j])===true && 
				gameObjArr[i][j].image != img3){
				initialPath.push([currentRabbit, gameObjArr[i][j]]);
			} 
		}
	}
	return initialPath; 
}

// Get the walkablePath array
function generatePath(){ 
	var walkablePath = [];
	var finalPath = [];
	// continue to loop the walkablePath array to 
	// addd new nodes to the walkablePath array so that
	// it can create all paths including the incompelte ones 
	// and the complete ones.
	walkablePath = initPath();
	shuffle(walkablePath);
	if(walkablePath.length > 0) {
		for(var v=0; v<walkablePath.length; v++){
			var last = walkablePath[v].length-1; 
			if(walkablePath[v][last].x !==0 && 
			   walkablePath[v][last].y !==0 && 
			   walkablePath[v][last].x !=10 && 
			   walkablePath[v][last].y !=224 && 
			   walkablePath[v][last].x !=224 && 
			   walkablePath[v][last].x !=234) {
				for(var i = 0; i < gameObjArr.length; i++){
					for(var j = 0; j < gameObjArr[i].length; j++){
						if(isNeighbor(walkablePath[v][last], gameObjArr[i][j])===true && 
						   gameObjArr[i][j].image != img3) {
							var tempCounter = 0; 
							for(var n=1; n<=last; n++){ 
								if(isNeighbor(gameObjArr[i][j], walkablePath[v][last-n])===true){
									tempCounter++;
								}
							}
							if(tempCounter===0){
								walkablePath.push(walkablePath[v].concat([gameObjArr[i][j]]));
							}
						} 	
					}	
				} // end of for loop of gameObjArr array	  
			}  // end of if 
			// When the generated paths exceed 10000, it
			// will slow down the game. So, we 
			// limit the number of paths genereated 
			// and it won't affect the performance.
			else {
				finalPath.push(walkablePath[v]);
				if(finalPath.length >=8000){break;}
			}
		}// end of for loop of walkablePath array
		
	}// end of if
	return finalPath;
 }


function isNeighbor(currNode, otherNode){
	var isNb = true;
	if((Math.abs(currNode.x-otherNode.x) + Math.abs(currNode.y-otherNode.y)) > 0 && 
		(Math.abs(currNode.x-otherNode.x) + Math.abs(currNode.y-otherNode.y))<=DISTANCE_CONS){
		return isNb;
	}
}

// shuffle the walkable path array to 
// make the rabbit move unpredictable
function shuffle(array) {
    var counter = array.length, temp, index;

    // While there are elements in the array
    while (counter > 0) {
        // Pick a random index
        index = Math.floor(Math.random() * counter);
        // Decrease counter by 1
        counter--;
        // And swap the last element with it
        temp = array[counter];
        array[counter] = array[index];
        array[index] = temp;
    }
}